<?php
namespace Bushelpowered\Api\Aggregator\Crm\V1\Request;
        
class CreateFollowUpTaskRequest 
{
    /** @var string $content The content of the activity, editable, 1000 character limit*/
    public string $content;
    /** @var null|string $assignedTo the UUID of the user that the task is assigned to*/
    public ?string $assignedTo = null;
    /** @var null|string $dueDate the due date of the task of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $dueDate = null;

    /**
     * @param  string  $content The content of the activity, editable, 1000 character limit
     * @param  null|string  $assignedTo the UUID of the user that the task is assigned to
     * @param  null|string  $dueDate the due date of the task of yyyy-MM-dd format, IE: 2023-10-04
     */
    public function __construct(string $content, ?string $assignedTo, ?string $dueDate)
    {
        $this->content = $content;
        $this->assignedTo = $assignedTo;
        $this->dueDate = $dueDate;
    }
    

}