<?php
namespace Bushelpowered\Api\Aggregator\Crm\V1\Response;
        
class UserAssignmentResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $customerId The UUID of the customer associated to the userId*/
    public string $customerId;
    /** @var string $userId The UUID of the user associated to the customerId*/
    public string $userId;
    /** @var string $userName The name of the user associated to the customerId*/
    public string $userName;
    /** @var string $createdBy The name of the user that created the note*/
    public string $createdBy;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $customerId The UUID of the customer associated to the userId
     * @param  string  $userId The UUID of the user associated to the customerId
     * @param  string  $userName The name of the user associated to the customerId
     * @param  string  $createdBy The name of the user that created the note
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $customerId, string $userId, string $userName, string $createdBy, string $createdAt)
    {
        $this->id = $id;
        $this->customerId = $customerId;
        $this->userId = $userId;
        $this->userName = $userName;
        $this->createdBy = $createdBy;
        $this->createdAt = $createdAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
}