<?php
namespace Bushelpowered\Api\Businesspages\V1\Model;
        
class Location 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $tenantId The tenant identifier.*/
    public string $tenantId;
    /** @var string $datasourceId The datasource identifier.*/
    public string $datasourceId;
    /** @var string $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.*/
    public string $integrationId;
    /** @var string $sourceId The source record identifier.*/
    public string $sourceId;
    /** @var null|string $sourceName The record's source name*/
    public ?string $sourceName = null;
    /** @var null|string $internalName The customer or user's name for a location; not for growers*/
    public ?string $internalName = null;
    /** @var null|string $publicName What the grower or a customer's customer will see for location name*/
    public ?string $publicName = null;
    /** @var null|string $physicalAddressLine1 First line of a standard US postal address*/
    public ?string $physicalAddressLine1 = null;
    /** @var null|string $physicalAddressLine2 Second line of a standard US postal address*/
    public ?string $physicalAddressLine2 = null;
    /** @var null|string $physicalLocality Physical locality*/
    public ?string $physicalLocality = null;
    /** @var null|string $physicalAdministrativeArea Physical administrative area*/
    public ?string $physicalAdministrativeArea = null;
    /** @var null|string $physicalPostalCode Physical postal code*/
    public ?string $physicalPostalCode = null;
    /** @var null|string $physicalCountryCode Physical country code*/
    public ?string $physicalCountryCode = null;
    /** @var null|string $businessPhone Business phone*/
    public ?string $businessPhone = null;
    /** @var null|string $businessFax Business fax*/
    public ?string $businessFax = null;
    /** @var null|string $businessEmail Business Email*/
    public ?string $businessEmail = null;
    /** @var null|string $businessWebsite Business website*/
    public ?string $businessWebsite = null;
    /** @var string[]|null $businessType */
    public ?array $businessType = null;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $tenantId The tenant identifier.
     * @param  string  $datasourceId The datasource identifier.
     * @param  string  $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.
     * @param  string  $sourceId The source record identifier.
     * @param  null|string  $sourceName The record's source name
     * @param  null|string  $internalName The customer or user's name for a location; not for growers
     * @param  null|string  $publicName What the grower or a customer's customer will see for location name
     * @param  null|string  $physicalAddressLine1 First line of a standard US postal address
     * @param  null|string  $physicalAddressLine2 Second line of a standard US postal address
     * @param  null|string  $physicalLocality Physical locality
     * @param  null|string  $physicalAdministrativeArea Physical administrative area
     * @param  null|string  $physicalPostalCode Physical postal code
     * @param  null|string  $physicalCountryCode Physical country code
     * @param  null|string  $businessPhone Business phone
     * @param  null|string  $businessFax Business fax
     * @param  null|string  $businessEmail Business Email
     * @param  null|string  $businessWebsite Business website
     * @param  string[]|null  $businessType 
     */
    public function __construct(string $id, string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceName, ?string $internalName, ?string $publicName, ?string $physicalAddressLine1, ?string $physicalAddressLine2, ?string $physicalLocality, ?string $physicalAdministrativeArea, ?string $physicalPostalCode, ?string $physicalCountryCode, ?string $businessPhone, ?string $businessFax, ?string $businessEmail, ?string $businessWebsite, ?array $businessType)
    {
        $this->id = $id;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceName = $sourceName;
        $this->internalName = $internalName;
        $this->publicName = $publicName;
        $this->physicalAddressLine1 = $physicalAddressLine1;
        $this->physicalAddressLine2 = $physicalAddressLine2;
        $this->physicalLocality = $physicalLocality;
        $this->physicalAdministrativeArea = $physicalAdministrativeArea;
        $this->physicalPostalCode = $physicalPostalCode;
        $this->physicalCountryCode = $physicalCountryCode;
        $this->businessPhone = $businessPhone;
        $this->businessFax = $businessFax;
        $this->businessEmail = $businessEmail;
        $this->businessWebsite = $businessWebsite;
        $this->businessType = $businessType;
    }
    

}