<?php
namespace Bushelpowered\Api\Data\Analytics\V1\Response;
        
class InvoiceLineResponse 
{
    /** @var null|string $sourceDescription Description of the line item, may include product or service details.*/
    public ?string $sourceDescription = null;
    /** @var null|string $sourceProductName Name of the product or service for this line item, if available.*/
    public ?string $sourceProductName = null;
    /** @var string $sourceProductId Unique identifier for the product or service in the source system.*/
    public string $sourceProductId;
    /** @var float $sourceQuantityAmount Quantity of the product or service billed in this line item.*/
    public float $sourceQuantityAmount;
    /** @var null|string $sourceQuantityUom Unit of measure for the quantity, if specified (e.g., 'gal', 'bags').*/
    public ?string $sourceQuantityUom = null;
    /** @var float $sourceUnitPrice Unit price for the product or service in this line item.*/
    public float $sourceUnitPrice;
    /** @var null|string $sourceUnitPriceUom Unit of measure for the unit price, if specified.*/
    public ?string $sourceUnitPriceUom = null;
    /** @var float $sourceSubtotal Subtotal amount for this line item before taxes.*/
    public float $sourceSubtotal;
    /** @var null|float $sourceTax Tax amount applied to this line item, if available.*/
    public ?float $sourceTax = null;

    /**
     * @param  null|string  $sourceDescription Description of the line item, may include product or service details.
     * @param  null|string  $sourceProductName Name of the product or service for this line item, if available.
     * @param  string  $sourceProductId Unique identifier for the product or service in the source system.
     * @param  float  $sourceQuantityAmount Quantity of the product or service billed in this line item.
     * @param  null|string  $sourceQuantityUom Unit of measure for the quantity, if specified (e.g., 'gal', 'bags').
     * @param  float  $sourceUnitPrice Unit price for the product or service in this line item.
     * @param  null|string  $sourceUnitPriceUom Unit of measure for the unit price, if specified.
     * @param  float  $sourceSubtotal Subtotal amount for this line item before taxes.
     * @param  null|float  $sourceTax Tax amount applied to this line item, if available.
     */
    public function __construct(?string $sourceDescription, ?string $sourceProductName, string $sourceProductId, float $sourceQuantityAmount, ?string $sourceQuantityUom, float $sourceUnitPrice, ?string $sourceUnitPriceUom, float $sourceSubtotal, ?float $sourceTax)
    {
        $this->sourceDescription = $sourceDescription;
        $this->sourceProductName = $sourceProductName;
        $this->sourceProductId = $sourceProductId;
        $this->sourceQuantityAmount = $sourceQuantityAmount;
        $this->sourceQuantityUom = $sourceQuantityUom;
        $this->sourceUnitPrice = $sourceUnitPrice;
        $this->sourceUnitPriceUom = $sourceUnitPriceUom;
        $this->sourceSubtotal = $sourceSubtotal;
        $this->sourceTax = $sourceTax;
    }
    

}