<?php
namespace Bushelpowered\Api\Finops\Aggregator\V1;

use \Bushelpowered\Api\Finops\Aggregator\V1\Requests\AddDealerRequest;
use \Bushelpowered\Api\Finops\Aggregator\V1\Responses\AddDealerResponse;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bidl\Php\Core\Builtins\UnknownError;

class AddDealer 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(AddDealerRequest $request, $headers): AddDealerResponse | NotAuthenticated | NotAuthorized | BadRequest | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/finops/aggregator/v1/AddDealer', $request, $this->getWrapper(), $headers);
    }
    
    public function request(AddDealerRequest $request, AddDealerMetadata $hasHeaders): AddDealerResponse | NotAuthenticated | NotAuthorized | BadRequest | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/finops/aggregator/v1/AddDealer', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var AddDealerResponse | NotAuthenticated | NotAuthorized | BadRequest | ConstraintViolation | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.finops.aggregator.v1#AddDealerSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Finops\Aggregator\V1\Responses\AddDealerResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#ConstraintViolation':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}