<?php
namespace Bushelpowered\Api\Finops\Aggregator\V1;

use \Bushelpowered\Api\Finops\Aggregator\V1\Requests\RemoveDealerRequest;
use \Bushelpowered\Api\Common\Response\EmptyResponse;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\NotFound;
use \Bidl\Php\Core\Builtins\UnknownError;

class RemoveDealer 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(RemoveDealerRequest $request, $headers): EmptyResponse | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/finops/aggregator/v1/RemoveDealer', $request, $this->getWrapper(), $headers);
    }
    
    public function request(RemoveDealerRequest $request, RemoveDealerMetadata $hasHeaders): EmptyResponse | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/finops/aggregator/v1/RemoveDealer', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var EmptyResponse | NotAuthenticated | NotAuthorized | NotFound | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.finops.aggregator.v1#RemoveDealerSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\Response\EmptyResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotFound':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}