<?php
namespace Bushelpowered\Api\Fulfillment\Ticket\V1\Response;
        
class TicketSummaryResponse 
{
    /** @var string $commodityCode The commodity code that is found on the Configuration.GetCommodities response.*/
    public string $commodityCode;
    /** @var int $ticketCount */
    public int $ticketCount;
    /** @var float $grossUnitSum */
    public float $grossUnitSum;
    /** @var string $grossUnitSumUom */
    public string $grossUnitSumUom;
    /** @var float $netUnitSum */
    public float $netUnitSum;
    /** @var string $netUnitSumUom */
    public string $netUnitSumUom;
    /** @var float $netWeightSum */
    public float $netWeightSum;
    /** @var string $netWeightSumUom */
    public string $netWeightSumUom;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\RemarkResponse[] $remarkAverages A list of remarks and their average values*/
    public array $remarkAverages;

    /**
     * @param  string  $commodityCode The commodity code that is found on the Configuration.GetCommodities response.
     * @param  int  $ticketCount 
     * @param  float  $grossUnitSum 
     * @param  string  $grossUnitSumUom 
     * @param  float  $netUnitSum 
     * @param  string  $netUnitSumUom 
     * @param  float  $netWeightSum 
     * @param  string  $netWeightSumUom 
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\RemarkResponse[]  $remarkAverages A list of remarks and their average values
     */
    public function __construct(string $commodityCode, int $ticketCount, float $grossUnitSum, string $grossUnitSumUom, float $netUnitSum, string $netUnitSumUom, float $netWeightSum, string $netWeightSumUom, array $remarkAverages)
    {
        $this->commodityCode = $commodityCode;
        $this->ticketCount = $ticketCount;
        $this->grossUnitSum = $grossUnitSum;
        $this->grossUnitSumUom = $grossUnitSumUom;
        $this->netUnitSum = $netUnitSum;
        $this->netUnitSumUom = $netUnitSumUom;
        $this->netWeightSum = $netWeightSum;
        $this->netWeightSumUom = $netWeightSumUom;
        $this->remarkAverages = $remarkAverages;
    }
    

}