<?php
namespace Bushelpowered\Api\Iam\Access\Common\V1;
        
class RoleRef implements \Bushelpowered\Api\Iam\Access\Common\V1\HasOptionalTenantId
{
    /** @var string $roleId The role ref*/
    public string $roleId;
    /** @var null|string $tenantId The id of the tenant or null when owned by root.*/
    public ?string $tenantId = null;

    /**
     * @param  string  $roleId The role ref
     * @param  null|string  $tenantId The id of the tenant or null when owned by root.
     */
    public function __construct(string $roleId, ?string $tenantId)
    {
        $this->roleId = $roleId;
        $this->tenantId = $tenantId;
    }
    
    /**
     * @return null|string The id of the tenant or null when owned by root.
     */
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}