<?php
namespace Bushelpowered\Api\Iam\Access\Evaluate\V1\Response;
        
class SubjectPermissionResult implements \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasOptionalResultWindow
{
    /** @var \Bushelpowered\Api\Iam\Access\Common\V1\SubjectRef $subject */
    public \Bushelpowered\Api\Iam\Access\Common\V1\SubjectRef $subject;
    /** @var \Bushelpowered\Api\Iam\Access\Evaluate\V1\Response\PermissionResult[] $permissions The permission results for the subject*/
    public array $permissions;
    /** @var null|\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ConsistencyToken $resultWindow */
    public ?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ConsistencyToken $resultWindow = null;

    /**
     * @param  \Bushelpowered\Api\Iam\Access\Common\V1\SubjectRef  $subject 
     * @param  \Bushelpowered\Api\Iam\Access\Evaluate\V1\Response\PermissionResult[]  $permissions The permission results for the subject
     * @param  null|\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ConsistencyToken  $resultWindow 
     */
    public function __construct(\Bushelpowered\Api\Iam\Access\Common\V1\SubjectRef $subject, array $permissions, ?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ConsistencyToken $resultWindow)
    {
        $this->subject = $subject;
        $this->permissions = $permissions;
        $this->resultWindow = $resultWindow;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ConsistencyToken 
     */
    public function getResultWindow(): ?\Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ConsistencyToken
    {
        return $this->resultWindow;
    }
}