<?php
namespace Bushelpowered\Api\Iam\Access\Manage\V1\Request;
        
class UpdateSubjectGroupMembersRequest 
{
    /** @var string $id The id of the group to update members on*/
    public string $id;
    /** @var \Bushelpowered\Api\Iam\Access\Common\V1\Subjectable[]|null $membersToAdd The members to add*/
    public ?array $membersToAdd = null;
    /** @var \Bushelpowered\Api\Iam\Access\Common\V1\Subjectable[]|null $membersToRemove The members to remove*/
    public ?array $membersToRemove = null;

    /**
     * @param  string  $id The id of the group to update members on
     * @param  \Bushelpowered\Api\Iam\Access\Common\V1\Subjectable[]|null  $membersToAdd The members to add
     * @param  \Bushelpowered\Api\Iam\Access\Common\V1\Subjectable[]|null  $membersToRemove The members to remove
     */
    public function __construct(string $id, ?array $membersToAdd, ?array $membersToRemove)
    {
        $this->id = $id;
        $this->membersToAdd = $membersToAdd;
        $this->membersToRemove = $membersToRemove;
    }
    

}