<?php
namespace Bushelpowered\Api\Markets\Aggregator\Bids\V1;

use \Bushelpowered\Api\Common\Request\UUIDRequest;
use \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\LocationContactInfoResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotFound;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetLocationContactInfo 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(UUIDRequest $request, $headers): LocationContactInfoResponse | BadRequest | NotFound | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/markets/aggregator/bids/v1/GetLocationContactInfo', $request, $this->getWrapper(), $headers);
    }
    
    public function request(UUIDRequest $request, GetLocationContactInfoMetadata $hasHeaders): LocationContactInfoResponse | BadRequest | NotFound | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/markets/aggregator/bids/v1/GetLocationContactInfo', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var LocationContactInfoResponse | BadRequest | NotFound | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.markets.aggregator.bids.v1#GetLocationContactInfoSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\LocationContactInfoResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotFound':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}