<?php
namespace Bushelpowered\Api\Markets\Hrvyst\Config\V1;

use \Bushelpowered\Api\Markets\Hrvyst\Config\V1\Request\UpdateDatasourceConfigurationRequest;
use \Bushelpowered\Api\Common\Config\Response\ConfigurationListResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class UpdateOrCreateDatasourceConfiguration 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(UpdateDatasourceConfigurationRequest $request, $headers): ConfigurationListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/markets/hrvyst/config/v1/UpdateOrCreateDatasourceConfiguration', $request, $this->getWrapper(), $headers);
    }
    
    public function request(UpdateDatasourceConfigurationRequest $request, UpdateOrCreateDatasourceConfigurationMetadata $hasHeaders): ConfigurationListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/markets/hrvyst/config/v1/UpdateOrCreateDatasourceConfiguration', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var ConfigurationListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.markets.hrvyst.config.v1#UpdateOrCreateDatasourceConfigurationSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\Config\Response\ConfigurationListResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}