<?php
namespace Bushelpowered\Api\Payments\V1;

use \Bushelpowered\Api\Common\Request\EmptyRequest;
use \Bushelpowered\Api\Payments\V1\Response\StaffGetRainforestSessionKeyResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\BadGateway;
use \Bushelpowered\Api\Common\NotImplemented;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\NotFound;
use \Bidl\Php\Core\Builtins\UnknownError;

class StaffGetRainforestSessionKey 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(EmptyRequest $request, $headers): StaffGetRainforestSessionKeyResponse | BadRequest | BadGateway | NotImplemented | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/payments/v1/StaffGetRainforestSessionKey', $request, $this->getWrapper(), $headers);
    }
    
    public function request(EmptyRequest $request, StaffGetRainforestSessionKeyMetadata $hasHeaders): StaffGetRainforestSessionKeyResponse | BadRequest | BadGateway | NotImplemented | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/payments/v1/StaffGetRainforestSessionKey', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var StaffGetRainforestSessionKeyResponse | BadRequest | BadGateway | NotImplemented | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.payments.v1#StaffGetRainforestSessionKeySuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Payments\V1\Response\StaffGetRainforestSessionKeyResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadGateway':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadGateway::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotImplemented':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotImplemented::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#ConstraintViolation':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotFound':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}