<?php
namespace Bushelpowered\Api\Platform\Message\V1\Request;
        
class SendMessageRequest 
{
    /** @var \Bushelpowered\Api\Platform\Message\V1\Request\MessageTargetData[] $targetData A list of targeting methods for the notification.*/
    public array $targetData;
    /** @var string $topic The topic the notification should be sent on. Used to find user preferences for the specific topic.*/
    public string $topic;
    /** @var null|string $title Used as a notification title, or an email subject.*/
    public ?string $title = null;
    /** @var null|string $body Used as the notification body or plain text body of an email.*/
    public ?string $body = null;
    /** @var \Bushelpowered\Api\Platform\Message\V1\Request\Channel[] $channels The channel specific data to send. Used to provide options specific to a channel, such as notification click actions.*/
    public array $channels;
    /** @var null|bool $dryRun Whether to actually send the notification. When dryRun = true, the service will still determine and return targets but not actually send the request.*/
    public ?bool $dryRun = null;

    /**
     * @param  \Bushelpowered\Api\Platform\Message\V1\Request\MessageTargetData[]  $targetData A list of targeting methods for the notification.
     * @param  string  $topic The topic the notification should be sent on. Used to find user preferences for the specific topic.
     * @param  null|string  $title Used as a notification title, or an email subject.
     * @param  null|string  $body Used as the notification body or plain text body of an email.
     * @param  \Bushelpowered\Api\Platform\Message\V1\Request\Channel[]  $channels The channel specific data to send. Used to provide options specific to a channel, such as notification click actions.
     * @param  null|bool  $dryRun Whether to actually send the notification. When dryRun = true, the service will still determine and return targets but not actually send the request.
     */
    public function __construct(array $targetData, string $topic, ?string $title, ?string $body, array $channels, ?bool $dryRun)
    {
        $this->targetData = $targetData;
        $this->topic = $topic;
        $this->title = $title;
        $this->body = $body;
        $this->channels = $channels;
        $this->dryRun = $dryRun;
    }
    

}