<?php
namespace Bushelpowered\Api\Platform\User\V1\Model;
        
class StaffStatusChanged implements \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $userId The primary unique identifier.*/
    public string $userId;
    /** @var string $tenantId The tenant identifier.*/
    public string $tenantId;
    /** @var bool $isStaff Whether a user is staff or not.*/
    public bool $isStaff;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $userId The primary unique identifier.
     * @param  string  $tenantId The tenant identifier.
     * @param  bool  $isStaff Whether a user is staff or not.
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $userId, string $tenantId, bool $isStaff, string $updatedAt)
    {
        $this->userId = $userId;
        $this->tenantId = $tenantId;
        $this->isStaff = $isStaff;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}