<?php
namespace Bushelpowered\Api\Trade\Config\V1\Response;
        
class LocationListConfigurationResponse implements \Bushelpowered\Api\Common\ReturnsPaginationTokens
{
    /** @var \Bushelpowered\Api\Trade\Config\V1\Model\LocationConfigurationListItem[] $locationConfigurations */
    public array $locationConfigurations;
    /** @var null|string $continuationToken A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.*/
    public ?string $continuationToken = null;

    /**
     * @param  \Bushelpowered\Api\Trade\Config\V1\Model\LocationConfigurationListItem[]  $locationConfigurations 
     * @param  null|string  $continuationToken A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.
     */
    public function __construct(array $locationConfigurations, ?string $continuationToken)
    {
        $this->locationConfigurations = $locationConfigurations;
        $this->continuationToken = $continuationToken;
    }
    
    /**
     * @return null|string A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.
     */
    public function getContinuationToken(): ?string
    {
        return $this->continuationToken;
    }
}