<?php
namespace Bushelpowered\Api\Trade\Esign\V1\Model;
        
class SignatureBox 
{
    /** @var string $accountId The Id of the account this signature box is assigned to.*/
    public string $accountId;
    /** @var int $x The x coordinate of the top left corner of the signature box.*/
    public int $x;
    /** @var int $y The y coordinate of the top left corner of the signature box.*/
    public int $y;
    /** @var int $width The width of the signature box.*/
    public int $width;
    /** @var int $height The height of the signature box.*/
    public int $height;
    /** @var int $page The page number of the document where the signature box is located.*/
    public int $page;
    /** @var bool $required Whether or not the signature box is required.*/
    public bool $required;
    /** @var \Bushelpowered\Api\Trade\Esign\V1\Domo\SignatureBoxType $boxType */
    public \Bushelpowered\Api\Trade\Esign\V1\Domo\SignatureBoxType $boxType;

    /**
     * @param  string  $accountId The Id of the account this signature box is assigned to.
     * @param  int  $x The x coordinate of the top left corner of the signature box.
     * @param  int  $y The y coordinate of the top left corner of the signature box.
     * @param  int  $width The width of the signature box.
     * @param  int  $height The height of the signature box.
     * @param  int  $page The page number of the document where the signature box is located.
     * @param  bool  $required Whether or not the signature box is required.
     * @param  \Bushelpowered\Api\Trade\Esign\V1\Domo\SignatureBoxType  $boxType 
     */
    public function __construct(string $accountId, int $x, int $y, int $width, int $height, int $page, bool $required, \Bushelpowered\Api\Trade\Esign\V1\Domo\SignatureBoxType $boxType)
    {
        $this->accountId = $accountId;
        $this->x = $x;
        $this->y = $y;
        $this->width = $width;
        $this->height = $height;
        $this->page = $page;
        $this->required = $required;
        $this->boxType = $boxType;
    }
    

}