<?php
namespace Bushelpowered\Api\Trade\Esign\V1\Request;
        
class EsignListFilters 
{
    /** @var string[]|null $accountIds The accountIds to filter by.*/
    public ?array $accountIds = null;
    /** @var null|string $requestDateStart The request date start to filter by. of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $requestDateStart = null;
    /** @var null|string $requestDateEnd The request date end to filter by. of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $requestDateEnd = null;
    /** @var string[]|null $statuses The statuses to filter by.*/
    public ?array $statuses = null;

    /**
     * @param  string[]|null  $accountIds The accountIds to filter by.
     * @param  null|string  $requestDateStart The request date start to filter by. of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|string  $requestDateEnd The request date end to filter by. of yyyy-MM-dd format, IE: 2023-10-04
     * @param  string[]|null  $statuses The statuses to filter by.
     */
    public function __construct(?array $accountIds, ?string $requestDateStart, ?string $requestDateEnd, ?array $statuses)
    {
        $this->accountIds = $accountIds;
        $this->requestDateStart = $requestDateStart;
        $this->requestDateEnd = $requestDateEnd;
        $this->statuses = $statuses;
    }
    

}