<?php
namespace Bushelpowered\Api\Trade\Esign\V1\Request;
        
class EsignListPagination implements \Bushelpowered\Api\Common\PaginationBase
{
    /** @var null|\Bushelpowered\Api\Trade\Esign\V1\Request\EsignListFilters $filters */
    public ?\Bushelpowered\Api\Trade\Esign\V1\Request\EsignListFilters $filters = null;
    /** @var null|string $token A continuation token.*/
    public ?string $token = null;
    /** @var null|int $pageSize The desired size of pages, subject to service-imposed limitations.*/
    public ?int $pageSize = null;

    /**
     * @param  null|\Bushelpowered\Api\Trade\Esign\V1\Request\EsignListFilters  $filters 
     * @param  null|string  $token A continuation token.
     * @param  null|int  $pageSize The desired size of pages, subject to service-imposed limitations.
     */
    public function __construct(?\Bushelpowered\Api\Trade\Esign\V1\Request\EsignListFilters $filters, ?string $token, ?int $pageSize)
    {
        $this->filters = $filters;
        $this->token = $token;
        $this->pageSize = $pageSize;
    }
    
    /**
     * @return null|string A continuation token.
     */
    public function getToken(): ?string
    {
        return $this->token;
    }
    /**
     * @return null|int The desired size of pages, subject to service-imposed limitations.
     */
    public function getPageSize(): ?int
    {
        return $this->pageSize;
    }
}