<?php

namespace Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto;

class DynamicPageElement
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'textInput' => '\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\TextInputPageElement',
        'titleAndMessage' => '\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\TitleAndDynamicMessagePageElement',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function TextInput(\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\TextInputPageElement $data): DynamicPageElement
    {
        return new DynamicPageElement('textInput', $data);
    }
    public static function TitleAndMessage(\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\TitleAndDynamicMessagePageElement $data): DynamicPageElement
    {
        return new DynamicPageElement('titleAndMessage', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    